# -*- coding: utf-8 -*-
"""
Created on Mon Dec  3 00:14:57 2018

@author: Anna
"""
import weka.core.jvm as jvm
import weka.core.converters as converters
from weka.filters import Filter
from weka.classifiers import Classifier, Evaluation
from weka.core.classes import Random

jvm.start()

dataset = converters.load_any_file("C:\\Users\\Anna\Dropbox\\LBI\\2017-LBI\\data1\\census.arff")
natt = dataset.num_attributes
print(dataset.num_instances)

dataset.class_is_last()

for perc in range(20,85,5):
    print("perc = ", perc)
    # dataset split
    s = str(perc)
    r = Filter(classname="weka.filters.supervised.instance.Resample")
    r.options = ["-no-replacement", "-Z", str(perc)]
    r.inputformat(dataset)         # let the filter know about the type of data to filter
    training = r.filter(dataset)
    r.options=["-no-replacement", "-Z", str(perc), "-V"]
    test = r.filter(dataset)
    print("Training size = ") 
    print(training.num_instances)
    print(test.num_instances)
    

    #Training    
    cls = Classifier(classname="weka.classifiers.trees.J48")
    cls.options = ["-M", "200"]
    cls.build_classifier(training)
			
	#test
    evaluation = Evaluation(test)                     # initialize with priors
    evaluation.crossvalidate_model(cls, test, 10, Random(42))  
    accuracy = evaluation.percent_correct
    print("accuracy = ", accuracy)
